﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Kresleni
{
    public partial class Okno : Form
    {
        private Bitmap bitmap;

        public Okno()
        {
            InitializeComponent();
            int w = pictureBox.Width;
            int h = pictureBox.Height;
            bitmap = new Bitmap(w, h);
            Graphics g = Graphics.FromImage(bitmap);
            g.FillRectangle (Brushes.White, 0, 0, w-1, h-1);
            pictureBox.Image = bitmap;
            // pictureBox.Invalidate();
        }

        int X0, Y0;
        bool stisknuto = false;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            stisknuto = true;
            X0 = e.X;
            Y0 = e.Y;
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                stisknuto = false;
                Graphics g = Graphics.FromImage(pictureBox.Image);
                int X1 = e.X;
                int Y1 = e.Y;

                int X = X0 < X1 ? X0 : X1;
                int Y = Math.Min (Y0, Y1); 

                int W = Math.Abs (X0 - X1);
                int H = Math.Abs (Y0 - Y1);

                // using System.Drawing.Drawing2D;
                LinearGradientBrush b = new LinearGradientBrush 
                    (new Point (X, Y), new Point(X+W-1, Y+H-1), 
                     color, color2);

                // g.FillRectangle(b, X, Y, W, H);
                g.FillEllipse(b, X, Y, W, H);

                Pen pen = new Pen (penColor);
                pen.Width = 5;
                // g.DrawRectangle(pen, X, Y, W, H);
                g.DrawEllipse(pen, X, Y, W, H);

                pictureBox.Invalidate();
            }
        }

        private Color penColor = Color.Yellow;
        private Color color = Color.Blue;
        private Color color2 = Color.Red;

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            Control p = (Control) sender;
            if (e.Button == MouseButtons.Right)
                penColor = p.BackColor;
            else if (e.Button == MouseButtons.Middle)
                color2 = p.BackColor;
            else
                color = p.BackColor;
        }

        private void panel1_DoubleClick(object sender, EventArgs e)
        {
            Control p = (Control)sender;
            if (colorDialog.ShowDialog() == DialogResult.OK)
            {
                p.BackColor = colorDialog.Color;
                color = p.BackColor;
            }
        }
    }
}
